/*
 Languages for Scientific Computing
 ----
*/
// to compile:
// gcc test11b.c -o outputname -Wall

#include <stdlib.h>   // (almost) always necessary
#include <stdio.h>    // (almost) always necessary


double* createMatrix( int size );
int createMatrix2( double **matrix, int size ); 
int myPrint( double* array, char *name, int n );
int changeVal( double *variable, double value )
{ printf("changeVal!\n"); *variable = value; return 0; }


int main(int argc, char *argv[] )
{
   // #11b  
   // memory allocation
   // more on pointers

   int n;
   double array[] = {4.4, 3.3, 2.2, 1.1};
   
   if(argc == 1){
      printf(" argument needed: pass me an integer\n");
      return( -1 );
   }
   else n = atoi(argv[1]);


   double v; 
   printf( "v - before=%g\n", v );
   changeVal( &v, 1.0*n );
   printf( "v - after=%g\n", v );


   double *w;
   //   *w = -15.0;                      // no!!!!  
   // printf( "\n*w = %g\n", *w );




   w = &array[2];  // initialization!!! 
   *w = 5.0;       // now it's ok
   printf( "*w - before:\t %g\n", *w );
   changeVal( w, 10. * n );
   printf( "*w - after:\t %g\n", *w  );
   myPrint( array, "A", 5 );




   double *w2, k = 7.77;
   w2 = &k;  // init
   printf( "*w2 - before:\t %g\n", *w2 );
   changeVal( w2, 100. * n );
   printf( "*w2 - after:\t %g\n", *w2  );

   
   w2 = (double *) malloc( sizeof( double ) ); // yet another way to init a pointer
   printf( "*w2 malloc - before:\t %g\n", *w2 );
   *w2 = 1234.5678;
   printf( "*w2 malloc - after:\t %g\n", *w2  );
   


  
   
   int i;
   double *matrix;      // matrix will be a matrix
   matrix = createMatrix( n );
   myPrint( matrix, "uninitializedMatrix", n );
   for( i=n; i>0; i-- ) matrix[i-1]=i;
   myPrint( matrix, "initializedMatrix", n );
   free( matrix );

   
   
   double *matrix2;  
   createMatrix2( &matrix2, n );
   myPrint( matrix2, "outside", n );
   free( matrix2 );
   

   
   return( 0 );
}


double* createMatrix( int size )
{
   return( (double *) malloc( size * sizeof( double ) ) );
}



int createMatrix2( double **matrix, int n )
{
   int i;
   double *M;
   M = (double *) malloc( n * sizeof(double) );
   if(M == NULL){
      fprintf(stderr, "Not enough memory to allocate %ld bytes.", 
	      n * sizeof(double) );
      return( 1 );
   }

   // *matrix = (double *) malloc( n * sizeof(double) );

   for( i=n; i>0; i-- ) M[i-1]=i;
   myPrint( M, "inside", n );

   *matrix = M; 
   
   return( 0 );
}




int myPrint( double* array, char *name, int n )
{
   int i;

   printf(" %s = [", name );
   for( i=0; i<n; i++ ) printf("%g ", array[i] );
   printf("];\n");

   return( 0 );
}

